### Enumeration

# Gdk TouchpadGesturePhase

since: 4.0

#### Declaration

    enum Gdk.TouchpadGesturePhase

#### Description [src]

Specifies the current state of a touchpad gesture.

All gestures are guaranteed to begin with an event with phase `GDK_TOUCHPAD_GESTURE_PHASE_BEGIN`, followed by 0 or several events with phase `GDK_TOUCHPAD_GESTURE_PHASE_UPDATE`.

A finished gesture may have 2 possible outcomes, an event with phase `GDK_TOUCHPAD_GESTURE_PHASE_END` will be emitted when the gesture is considered successful, this should be used as the hint to perform any permanent changes.

Cancelled gestures may be so for a variety of reasons, due to hardware or the compositor, or due to the gesture recognition layers hinting the gesture did not finish resolutely (eg. a 3rd finger being added during a pinch gesture). In these cases, the last event will report the phase `GDK_TOUCHPAD_GESTURE_PHASE_CANCEL`, this should be used as a hint to undo any visible/permanent changes that were done throughout the progress of the gesture.

Available since: 4.0

#### Members

`GDK_TOUCHPAD_GESTURE_PHASE_BEGIN`

  The gesture has begun.

  - Value: `0`
  - Nickname: `begin`
  - Available since: 4.0
`GDK_TOUCHPAD_GESTURE_PHASE_UPDATE`

  The gesture has been updated.

  - Value: `1`
  - Nickname: `update`
  - Available since: 4.0
`GDK_TOUCHPAD_GESTURE_PHASE_END`

  The gesture was finished, changes should be permanently applied.

  - Value: `2`
  - Nickname: `end`
  - Available since: 4.0
`GDK_TOUCHPAD_GESTURE_PHASE_CANCEL`

  The gesture was cancelled, all changes should be undone.

  - Value: `3`
  - Nickname: `cancel`
  - Available since: 4.0